//+------------------------------------------------------------------+
//|       Dserg_Morning_v1.0.mq4                                        |
//|         EURUSD_M15 / 2009                      |
//+------------------------------------------------------------------+
#property copyright "Dserg"
#property link      "http://forum.alpari.ru/member56010.html"
#include <stdlib.mqh>

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
extern double Lots = 1.0;

extern double s0 = 0.0;
extern double t0 = 1.618;
extern int h1=0;
extern int h2=7;
extern double BoxShift=0.0;
extern double MinBox = 0.0;
extern double MaxBox = 10000.0;
double BoxH,BoxL;
extern bool leaveOpposite=false;

static datetime LT=0;
int MagicNumber=7461240;        
extern double Fact=4.0;
extern int Nmax=4;
static int n=0;
static double Coeff=1.0;
static double lastB=0.0;
extern double initBox = 1332.0;
static double RiskCoeff = 1.0;
int init()
{
   LT=Time[0];
   
   n=0;
   Coeff=1.0;
   lastB=AccountBalance();
   RiskCoeff=1.0;
   initBox *=Point;
   
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//| OpenBuyStopOrder                                                    |
//| If Stop Loss or TakeProfit are used the values are calculated    |
//| for each trade                                                   |
//+------------------------------------------------------------------+
void OpenBuyStopOrder()
{
   int err,ticket;
   double myStopLoss = 0, myTakeProfit = 0;
   myStopLoss = 0;
   myTakeProfit = 0;
   
   RefreshRates();
   
   //    
   myStopLoss = NormalizeDouble(BoxL+s0*(BoxH-BoxL),Digits);
   myTakeProfit = NormalizeDouble(BoxH+(BoxH-BoxL)*(t0-1.0),Digits);
   
   //  
   double P0 = NormalizeDouble(BoxH,Digits);  
   
   ticket=OrderSend(Symbol(),OP_BUYSTOP,NormalizeDouble(RiskCoeff*Coeff*Lots,2),P0,30,myStopLoss,myTakeProfit,"forward",MagicNumber,0,Green); 
   if(ticket<=0)
   {
      err = GetLastError();
      Print("Error opening BUYSTOP order [" + "]: (" + err + ") " + ErrorDescription(err)); 
   }
}


//+------------------------------------------------------------------+
//| OpenSellStopOrder                                                    |
//| If Stop Loss or TakeProfit are used the values are calculated    |
//| for each trade                                                   |
//+------------------------------------------------------------------+
void OpenSellStopOrder()
{
   int err,ticket;
   double myStopLoss = 0, myTakeProfit = 0;
   myStopLoss = 0;
   myTakeProfit = 0;
   
   RefreshRates();
   
   //    
   myStopLoss = NormalizeDouble(BoxH-s0*(BoxH-BoxL),Digits);
   myTakeProfit = NormalizeDouble(BoxL-(BoxH-BoxL)*(t0-1.0),Digits);
   
   //  
   double P0 = NormalizeDouble(BoxL,Digits);  
   
   ticket=OrderSend(Symbol(),OP_SELLSTOP,NormalizeDouble(RiskCoeff*Coeff*Lots,2),P0,30,myStopLoss,myTakeProfit,"forward",MagicNumber,0,Red); 
   if(ticket<=0)
   {
      err = GetLastError();
      Print("Error opening SELLSTOP order [" + "]: (" + err + ") " + ErrorDescription(err)); 
   }
}


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----
   if (Time[0]==LT) return(0);
   LT = Time[0];

   if (Hour()<h2 && Hour()>h1) return(0);

   int Nb=openPositionsDet(OP_BUYSTOP,"forward");
   int Ns=openPositionsDet(OP_SELLSTOP,"forward");
   int Nb0=openPositionsDet(OP_BUY,"forward");
   int Ns0=openPositionsDet(OP_SELL,"forward");

   if (Hour()==h1 ) {
      if (Ns==1 && Nb==1 && n>0) {
         n--;
         Coeff /= Fact;
      }
         
      CloseBuyStopOrder();
      CloseSellStopOrder();
   }   

   
   if (Hour()==h2 && Nb==0 && Ns==0 && Nb0==0 && Ns0==0) {
//      BoxH = iHigh(NULL,PERIOD_H1,iHighest(NULL,PERIOD_H1,MODE_HIGH,h2-h1,0));
//      BoxL = iLow(NULL,PERIOD_H1,iLowest(NULL,PERIOD_H1,MODE_LOW,h2-h1,0));

      BoxH = iCustom(NULL,PERIOD_M15,"!LinRegrBuf",true,4*(h2-h1),2,0) + BoxShift*Point;
      BoxL = iCustom(NULL,PERIOD_M15,"!LinRegrBuf",true,4*(h2-h1),1,0) - BoxShift*Point;
      
      //   
      if (BoxH-BoxL>MinBox*Point && BoxH-BoxL<MaxBox*Point) {
      
         //  
        /* if (initBox==0.0) {
            initBox=BoxH-BoxL;
            Comment(DoubleToStr(initBox,5));
         }*/
         RiskCoeff = initBox/(BoxH-BoxL);
      
         // 
         if (lastB-AccountBalance()>0.0) {
            n++;
            Coeff *= Fact;
         } else {
            n=0;
            Coeff=1.0;
         }
         if (n>Nmax) {
            n=0;
            Coeff=1.0;
         }
      
         lastB = AccountBalance();   
      
      
         OpenBuyStopOrder();
         OpenSellStopOrder();
      }
   }   
   
   if (Nb==1 && Ns==0 && !leaveOpposite) {
      CloseBuyStopOrder();
   }   

   if (Nb==0 && Ns==1 && !leaveOpposite) {
      CloseSellStopOrder();
   }   
     

//----
   return(0);
}
//+------------------------------------------------------------------+

int openPositionsDet(int ORDER, string COMMENT)
{  int op =0;
     for(int i=OrdersTotal()-1;i>=0;i--)                                // scan all orders and positions...
      {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderMagicNumber() != MagicNumber) continue;
        if ( OrderSymbol()==Symbol() )
         {  
          if ( (OrderType() == ORDER)&&(OrderComment() == COMMENT) ) op++; 
         }
      } 
   return(op);
}
int CloseBuyStopOrder()
{
     for(int i=OrdersTotal()-1;i>=0;i--) {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderMagicNumber() != MagicNumber) continue;
        if ( OrderSymbol()==Symbol() ) {  
          if (OrderType() == OP_BUYSTOP) { 
            OrderDelete(OrderTicket(),Green);
          }
        }
    } 
    return(0);
}

int CloseSellStopOrder()
{
     for(int i=OrdersTotal()-1;i>=0;i--) {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderMagicNumber() != MagicNumber) continue;
        if ( OrderSymbol()==Symbol() ) {  
          if (OrderType() == OP_SELLSTOP) { 
            OrderDelete(OrderTicket(),Red);
          }
        }
    } 
    return(0);
}


